#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstring>
#include "parser.h"
using namespace std;

char *str_replace (char *orig, char *rep, char *with) { //  char *  char *
 char *result;
 char *ins;
 char *tmp;
 int len_rep;
 int len_with;
 int len_front;
 int count;
 if (!orig || !rep) return NULL;
 len_rep = strlen(rep);
 if (len_rep == 0) return NULL;
 if (!with) with = "";
 len_with = strlen(with);
 ins = orig;
 for (count = 0; tmp = strstr(ins, rep); ++count) {
  ins = tmp + len_rep;
 }
 tmp = result = new char [strlen(orig) + (len_with - len_rep) * count + 1];
 if (!result) return NULL;
 while (count--) {
  ins = strstr(orig, rep);
  len_front = ins - orig;
  tmp = strncpy(tmp, orig, len_front) + len_front;
  tmp = strcpy(tmp, with) + len_with;
  orig += len_front + len_rep;
 }
 strcpy (tmp, orig);
 return result;
}

void Go (char *p, double x1, double x2, double dX) {
 TParser *parser = new TParser();
 char xstr[80];
 try {
  for (double x = x1; x <= x2; x += dX) {
   sprintf (xstr,"%.3lf",x);
   char *p2 = str_replace(p, "x", xstr);
   parser->Compile(p2);
   parser->Evaluate();
   cout << endl << x << " " << parser->GetResult();
   delete p2;
  }
 }
 catch (TError error) {
  cout << "Error: " << error.error << " in position " << error.pos;
  return;
 }
 delete parser;
}

int main() {
 double x1 = 0, x2 = 2 * M_PI, dx = M_PI / 10;
  //  -    X  
 char *p = "sin(x)+x/2";
  //     f(x) -
 Go (p, x1, x2, dx);
 cin.get();
 return 0;
}

